#include	"rf.h"
#include 	<sys/types.h>
#include	<sys/uio.h>
#include	<sys/buf.h>
#include	"/sys/machine/param.h"
#include	"/sys/sundev/mbvar.h"
#include	<errno.h>
#include	"rfreg.h"

#define		VME_ADD_MOD	0xd

extern struct mb_driver rfcdriver;

/* Get a Direct Virtual Memory Address (DVMA) from a virtual kernel address */
#define	RF_ADDR(x) ((int)((int)(x) & 0xfffff))	/* DVMA address (20 bits) */

rfio(dev, rwflag, uio)
dev_t dev;
int rwflag;
struct uio *uio;
{
 	register int unit = UNIT(dev);
        PARMBLK stdpb;
 	struct mb_device *device = rfcdriver.mdr_dinfo[unit];
	char *addr;

        if (UNIT(dev) >= NRF)
                return(ENXIO);
        stdpb.id = 0;
        stdpb.control = 1;
        stdpb.unit = (device->md_slave * 2) + 1;
        stdpb.addrmod = VME_ADD_MOD;
        stdpb.diskaddr = 0;
        stdpb.reserved = 0;

        stdpb.blkcount = (uio->uio_iov->iov_len+511)/512;
        addr = (char *)rmalloc(iopbmap, stdpb.blkcount*512);
        stdpb.vmeaddr = RF_ADDR(addr);

	if (rwflag == B_WRITE) {
		bcopy(uio->uio_iov->iov_base, addr, uio->uio_iov->iov_len);
		stdpb.command = C_WRITE;
	} else
		stdpb.command = C_READ;

        if (putpb(&stdpb, device)) {
                return(EIO);
		}

	if (rwflag == B_READ)
		bcopy(addr, uio->uio_iov->iov_base, uio->uio_iov->iov_len);

        return(0);
} /* rfio */

mbsetup()
{
	panic("reached mbsetup!");
	}
mbrelse()
{
	panic("reached mbrelse!");
	}

getdevaddr(x)
int x;
{	return(x);
	}

void
minphys() {}

intsvc() { return 0; }

biodone()
{
	panic("reached biodone(iodone)!");
	}
